import 'package:easy/src/easy_bloc.dart';
import 'package:flutter/material.dart';
import 'bloc.dart';
import 'inject.dart';

class Core {
  DateTime createdAt = DateTime.now();
  final Map<String, EasyBloc> _injectMapBloc = {};

  final Map<String, Widget> _injectMapView = {};

  final List<Bloc> blocs;
 
  final List<Widget> views;
  final String tag;

  Core({this.blocs, this.views, this.tag});

  EasyBloc bloc<T extends EasyBloc>([Map<String, dynamic> params]) {
    String typeBloc = T.toString();
    T blocBase;
    if (_injectMapBloc.containsKey(typeBloc)) {
      blocBase = _injectMapBloc[typeBloc];
    } else {
      Bloc b = blocs.firstWhere((b) => b.inject is T Function(Inject));
      blocBase = b.inject(Inject(params: params, tag: tag));
      if (b.singleton) {
        _injectMapBloc[typeBloc] = blocBase;
      }
    }
    return blocBase;
  }

  removeBloc<T>() {
    String type = T.toString();
    if (_injectMapBloc.containsKey(type)) {
      try {
        _injectMapBloc[type].dispose();
      } catch (e) {
        print(e);
      }
      _injectMapBloc.remove(type);
    }
  }


  Widget view(String key) {
    if (!_injectMapView.containsKey(key)) throw "View not found";
    return _injectMapView[key];
  }

  dispose() {
    for (String key in _injectMapBloc.keys) {
      EasyBloc bloc = _injectMapBloc[key];
      bloc.dispose();
    }
    _injectMapBloc.clear();

  }
}
