import 'package:easy/src/easy_bloc.dart';
import 'easy_manager.dart';

class Inject<T> {
  Map<String, dynamic> params = {};
  final String tag;

  Inject({this.params, this.tag = "global"});

  factory Inject.of() => Inject(tag: T.toString());

  disposeBloc<T extends EasyBloc>() {
    return EasyManager.disposeBloc<T>(tag);
  }

  ///get injected bloc;
  T bloc<T extends EasyBloc>([Map<String, dynamic> params]) {
    params ??= {};
    return EasyManager.getBloc<T>(params, tag);
  }

  ///get injected bloc;
  T getBloc<T extends EasyBloc>([Map<String, dynamic> params]) {
    params ??= {};
    return bloc<T>(params);
  }
}
